/* Greybox Redux
 * Required: http://jquery.com/
 * Written by: John Resig
 * Based on code by: 4mir Salihefendic (http://amix.dk)
 * License: LGPL (read more in LGPL.txt)
 */

var path_to_close_img = 'js/greybox_redux/images/close.gif';

var GB_DONE = false;
var GB_HEIGHT = 400;
var GB_WIDTH = 400;

//----------------------------------------------------
// Safari Cache Prevention
//----------------------------------------------------
// To prevent Safari Cache, GB_Frame's ID must be 
// changed everytime greybox pops up.
//----------------------------------------------------
var GB_Frame_id_prefix = "GB_Frame";
var GB_Frame_id_idx = 1000;

function GB_Frame_GetID()
{
	return GB_Frame_id_prefix + GB_Frame_id_idx.toString();
}

function GB_Frame_IncID()
{
	GB_Frame_id_idx++;
}

//----------------------------------------------------
// IFrame Shim Technique
//----------------------------------------------------
// Hide the background html instead of IFrame Shim
// Technique
//----------------------------------------------------
//
//
//var boxoverShim;
//var b_do_shim = ( window.createPopup && !window.XmlHttpRequest );
//
//function Shim_init()
//{
//	if ( !b_do_shim ) return;
//	document.write('<IFRAME id="boxoverShim" src="" style="display: none; left: 0; top: 0; z-index: 0; position: absolute;" frameBorder="0" scrolling="no"></IFRAME>');
//    boxoverShim = document.getElementById( "boxoverShim" );
//}
//
//Shim_init();
//
//function Shim_show( boxoverObject )
//{
//	if ( !b_do_shim ) return;
//	try
//	{
//		with (boxoverShim.style)
//		{
//			left = boxoverObject.style.left;
//			top = boxoverObject.style.top;
//			width = boxoverObject.offsetWidth+"px";
//			height = boxoverObject.offsetHeight+"px";
//			zindex = -1;
//			filter = "progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0)";
//			display = "block";
//		}
//	}
//	catch (e)
//	{
//	}
//}
//
//function Shim_hide( boxoverObject )
//{
//	if ( !b_do_shim ) return;
//	try
//	{
//		boxoverShim.style.display = 'none';
//	}
//	catch (e)
//	{
//	}
//}
//

//----------------------------------------------------
// GB_show
//----------------------------------------------------
function GB_show(caption, url, height, width) {
	GB_HEIGHT = height || 400;
	GB_WIDTH = width || 400;

	if(!GB_DONE)
	{
/*
		$(document.body)
			.append( 
				"<div id='GB_overlay'></div>" +
				"<div id='GB_window'>" +
					"<div id='GB_caption'></div>" +
					"<img src='" + path_to_close_img + "' alt='Close window'/>" +
				"</div>"
			);
*/
		$(document.body)
			.append( 
				"<div id='GB_overlay'></div>" +
				"<div id='GB_window'>" +
				"</div>"
			);


		$("#GB_window img").click(GB_hide);

//-- [BEGIN] Make It Modal
		$("#GB_overlay").click( function( event ) {
			event.preventDefault();
		});
//-- [END] Make It Modal

		$(window).resize(GB_position);
		GB_DONE = true;
	}

//-- [BEGIN] Safari Cache Prevention
	$( "#" + GB_Frame_GetID() ).remove();
	GB_Frame_IncID();
	var GB_Frame_id = GB_Frame_GetID();
//-- [END] Safari Cache Prevention

	var scrolling = '';

//-- [BEGIN] IE6 Unnecessary Horizontal Scroll Bar Prevention
	if ( jQuery.browser.msie && ( jQuery.browser.version < 7.0 ) )
	{
		scrolling = "scrolling='yes' ";
	}
//-- [END] IE6 Unnecessary Horizontal Scroll Bar Prevention

	$( "#GB_window" ).append( "<iframe " + scrolling + "id='" + GB_Frame_id + "' src='" + url + "'></iframe>");

	$("#GB_caption").html(caption);

//-- [BEGIN] IE6 Overlay Problem
	if ( jQuery.browser.msie && jQuery.browser.version < 7.0 )
	{
		$("div:first").hide();
	}
//-- [END] IE6 Overlay Problem

//-- [BEGIN] Stretch Overlay Over Document
	$("#GB_overlay").css( "height", $(document).height() ); //<== Dimension PlugIn
//-- [END] Stretch Overlay Over Document

	$("#GB_overlay").show();

//-- [BEGIN] IFrame Shim Technique
/////Shim_show( document.getElementById('GB_overlay') );
//-- [END] IFrame Shim Technique

	GB_position();

	if(GB_ANIMATION)
		$("#GB_window").slideDown("slow");
	else
		$("#GB_window").show();
}

//----------------------------------------------------
// GB_hide
//----------------------------------------------------
function GB_hide() {

//-- [BEGIN] IFrame Shim Technique
/////Shim_hide( document.getElementById('GB_overlay') );
//-- [END] IFrame Shim Technique

//-- [BEGIN] IE6 Overlay Problem
	if ( jQuery.browser.msie && jQuery.browser.version < 7.0 )
	{
		$("div:first").show();
	}
//-- [END] IE6 Overlay Problem

	$("#GB_window,#GB_overlay").hide();
}

//----------------------------------------------------
// GB_position
//----------------------------------------------------
function GB_position() {

	var de = document.documentElement;
	var w = self.innerWidth || (de && de.clientWidth) || document.body.clientWidth;
	$("#GB_window").css({
		width:GB_WIDTH + "px",
		height:GB_HEIGHT + "px",
		left: ( ( w - GB_WIDTH) / 2 ) + "px",
		top: ( 20 + $(window).scrollTop() ) + "px"
	});

//-- [BEGIN] Safari Cache Prevention
	var GB_Frame_id = GB_Frame_GetID();
	//-- Since we change the id name of GB_Frame, we can not place
	//-- css attributes in .css file and so it must be modified here instead.
	$( "#" + GB_Frame_id ).css( "border", 0 );
	$( "#" + GB_Frame_id ).css( "overflow", "auto" );
	$( "#" + GB_Frame_id ).css( "width", "100%" );
//-- [END] Safari Cache Prevention

	var dy = 6;

//-- [BEGIN] Safari Height Correction
	if ( jQuery.browser.safari ) dy = 7;
//-- [END] Safari Height Correction

/* // with Caption
	var Caption_Font_Size = 22;
	var Caption_Top_Margin = 4;
	var Caption_Bottom_Margin = 4;
	dy += ( Caption_Font_Size + Caption_Top_Margin + Caption_Bottom_Margin );
*/
	// No caption
	if ( jQuery.browser.safari )
	{
		dy -= 5;
	}
	else if ( jQuery.browser.msie )
	{
		dy -= 5;
	}
	else if ( jQuery.browser.firefox )
	{
		dy -= 5;
	}
	else
	{
		dy -= 0;
	}

	$("#" + GB_Frame_id ).css( "height", GB_HEIGHT - dy + "px" );
}
