<?php
/*
=================================================================
AdFreely
Copyright (c) PhpKobo.com ( http://www.phpkobo.com/ )
Email : admin@phpkobo.com
ID : AF201_101

This software is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; version 2 of the
License.
=================================================================
*/

//----------------------------------------------------------------
// cls_fl_cell
//----------------------------------------------------------------
class cls_fl_cell extends cls_fl_aso
{
}

//----------------------------------------------------------------
// cls_cell_url_image
//----------------------------------------------------------------
class cls_cell_url_image extends CVText
{
	function Validate_Value( &$msg )
	{
		$v = $this->val;
		if ( !parent::Validate_Value( $msg ) ) return false;
		if ( !$this->Validate_ImageExt( $v ) ) return false;
		if ( !$this->Validate_Exists( $v ) ) return false;
		return true;
	}

	function Validate_ImageExt( $v )
	{
		$allowed_image_ext = split( ",", ALLOWED_PIC_EXT );
		$path_parts = pathinfo( $v );
		if ( isset( $path_parts['extension'] ) )
			$ext = $path_parts['extension'];
		else
			$ext = '';
		if ( !in_array( strtolower($ext), $allowed_image_ext ) )
		{
			$this->SetErrMsg( '[##c##] Invalid File Extension ##v##', $ext  );
			return false;
		}

		return true;
	}

	function Validate_Exists( $v )
	{
		$http = "http://";
		$https = "https://";
		if (
			( substr( $v, 0, strlen($http) ) != $http ) &&
			( substr( $v, 0, strlen($https) ) != $https )
		)
		{
			$this->SetErrMsg( '[##c##] Invalid Format : URL should start with "http://" or "https://"' );
			return false;
		}

		if (!( $handle = @fopen( $v, "r") ))
		{
			$this->SetErrMsg( '[##c##] Invalid URL : Please check your URL again.' );
			return false;
		}

		return true;
	}
}

//----------------------------------------------------------------
// cls_pic_up
//----------------------------------------------------------------
class cls_pic_up extends CVImageUpload
{
	function Setup()
	{
		$this->file_key = 'rs:def:' . $this->GetName() . "_inp";
		$this->ext_list = split( ",", ALLOWED_PIC_EXT );
		$this->fn_prefix = 'f_';

		$root_dir = PATH_PIC_ROOT;
		$this->path_tmp_storage = $root_dir . "tmp/";
		$this->path_sys_storage = $root_dir . "sys/";
		$this->path_empty_storage = $root_dir . "empty/";
		$this->empty_filename =  'no_pic.png';

		$root_url = URL_PIC_ROOT;
		$this->url_tmp_storage = $root_url . "tmp/";
		$this->url_sys_storage = $root_url . "sys/";
		$this->url_empty_storage = $root_url . "empty/";

		$this->max_pic_width = 180;
		$this->max_pic_height = 180;

		$this->fileup_max_filesize = FILEUP_MAX_FILESIZE;

		return nothing;
	}

	function ValidateUpload( $path, &$errmsg )
	{
		//-- [BEGIN] Get Image Dimention
		list($width, $height) = @getimagesize( $path );
		//-- [END] Get Image Dimention

		//-- [BEGIN] Check if file is image format
		if ( !isset( $width ) )
		{
			$errmsg = 'Invalid file format';
			return false;
		}
		//-- [END] Check if file is image format
/*
		//-- [BEGIN] Width Check
		if ( $width > $this->max_pic_width )
		{
			$errmsg = "The image width ( {$width} pixels ) exceeds the maximum limit ( " .
				sprintf( "%d", $this->max_pic_width ) . " pixels )";
			return false;
		}
		//-- [END] Width Check

		//-- [BEGIN] Height Check
		if ( $height > $this->max_pic_height )
		{
			$errmsg = "The image height ( {$height} pixels ) exceeds the maximum limit ( " .
				sprintf( "%d", $this->max_pic_height ) . " pixels )";
			return false;
		}
		//-- [END] Height Check
*/
		return true;
	}

	function Validate_Value( &$msg )
	{
		return true;
	}

	function &GetFileDisplay( &$msg )
	{
		$state = $this->GetState();

		switch ( $state )
		{
		case FILEUP_EMPTY_FILE:
		case FILEUP_STORED_FILE:
		case FILEUP_TEMP_FILE:
			$obj =& new COutHtml();
			$obj->SetTagName( 'img' );
			$obj->SetKV( 'src', $this->GetFileUrl() );
			$obj->SetKV( 'border', '0' );
			$w = ( isset( $this->width ) ? $this->width : "30" );
			$h = ( isset( $this->height ) ? $this->height : "30" );
			$obj->SetKV( 'width', $w );
			$obj->SetKV( 'height', $h );
			break;
		}

		return $obj;
	}
}

//----------------------------------------------------------------
// END OF FILE
//----------------------------------------------------------------
?>