<?php
/*
=================================================================
AdFreely
Copyright (c) PhpKobo.com ( http://www.phpkobo.com/ )
Email : admin@phpkobo.com
ID : AF201_101

This software is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; version 2 of the
License.
=================================================================
*/

$b_guest = ( $this->sys->GetUserType() == UT_GUEST );

$spec = array(

'cell_id'=>array(
XA_CLASS=>'CVPrimaryKey',
XA_CAPTION=>'Cell ID',
XA_SIZE=>9,
XA_REQUIRED=>false,
XA_MAX_CHAR=>9,
XA_SB_SIZE=>9,
XA_LIST=>'(sp)(sr)(key)(staff)'
),

'active'=>array(
XA_CLASS=>'cls_active',
XA_CAPTION=>'Active',
XA_INIT_VALUE=>array( 'reg'=>'Y', 'search'=>'Y' ),
XA_REQUIRED=>true,
XA_SELECT_ON_TOP=>STR_SELECT_CAPTION,
XA_SEARCH_OP=>'s=',
XA_LIST=>'(sp)(sr)(fd)(staff)'
),

'active_Y' => array(
XA_CLASS=>'CVRadio',
XA_NAME_RS=>nothing,
XA_REQUIRED=>false,
XA_LINKED_TO=>'active',
XA_RADIO_VALUE=>'Y',
XA_LIST=>'(fd)'
),

'active_N' => array(
XA_CLASS=>'CVRadio',
XA_NAME_RS=>nothing,
XA_REQUIRED=>false,
XA_LINKED_TO=>'active',
XA_RADIO_VALUE=>'N',
XA_LIST=>'(fd)'
),

'rlog_create_date_time'=>array(
XA_CLASS=>'cls_rlog_date_time',
XA_CAPTION=>RSTR_CREATE_DATE_TIME,
XA_FORMAT=>'Y-m-d H:i:s',
XA_LIST=>'(rlog)(reg_save)(sr)'
),

'rlog_create_user_type'=>array(
XA_CLASS=>'cls_rlog_user_type',
XA_CAPTION=>RSTR_CREATE_USER_TYPE,
XA_LIST=>'(rlog)(reg_save)'
),

'rlog_create_user_id'=>array(
XA_CLASS=>'cls_rlog_user_id',
XA_CAPTION=>RSTR_CREATE_USER_NAME,
XA_LIST=>'(rlog)(reg_save)'
),

'rlog_create_user_name'=>array(
XA_CLASS=>'cls_rlog_user_name',
XA_CAPTION=>RSTR_CREATE_USER_NAME,
XA_LIST=>'(rlog)(reg_save)(sr)'
),

'rlog_edit_date_time'=>array(
XA_CLASS=>'cls_rlog_date_time',
XA_CAPTION=>RSTR_EDIT_DATE_TIME,
XA_FORMAT=>'Y-m-d H:i:s',
XA_LIST=>'(rlog)(edit_save)'
),

'rlog_edit_user_type'=>array(
XA_CLASS=>'cls_rlog_user_type',
XA_CAPTION=>RSTR_EDIT_USER_TYPE,
XA_LIST=>'(rlog)(edit_save)'
),

'rlog_edit_user_id'=>array(
XA_CLASS=>'cls_rlog_user_id',
XA_CAPTION=>RSTR_EDIT_USER_NAME,
XA_LIST=>'(rlog)(edit_save)'
),

'rlog_edit_user_name'=>array(
XA_CLASS=>'cls_rlog_user_name',
XA_CAPTION=>RSTR_CREATE_USER_NAME,
XA_LIST=>'(rlog)(edit_save)'
),

'row_idx'=>array(
XA_CLASS=>'CVRowIndex',
XA_NAME_RS=>nothing,
XA_LIST=>'(sr)'
),

'ad_id'=>array(
XA_CLASS=>'CVAsciiText',
XA_CAPTION=>array( LC_ENG=>'Ad ID' ),
XA_SIZE=>24,
XA_SB_SIZE=>24,
XA_REQUIRED=>true,
XA_MIN_CHAR=>1,
XA_MAX_CHAR=>24,
XA_SEARCH_OP=>'s%',
XA_LIST=>'(sp)(sr)(fd)(staff)(g_reg_page1)'
),

'loc_type'=>array(
XA_CLASS=>'CVSelection',
XA_CAPTION=>'Location',
XA_REQUIRED=>$b_guest,
XA_SEL_TEXT=>SEL_LOC_TYPE,
XA_SELECT_ON_TOP=>null,
XA_SEARCH_OP=>'s=',
XA_LIST=>'(sp)(sr)(fd)(g_reg_page2)'
),

'loc_type_raw' => array(
XA_CLASS=>'CVAsciiText',
XA_NAME_RS=>nothing,
XA_REQUIRED=>false,
XA_LINKED_TO=>'loc_type',
XA_LIST=>'(fd)'
),

'loc_type_dummy'=>array(
XA_CLASS=>'CVText',
XA_NAME_RS=>'loc_type',
XA_LIST=>''
),

'loc_type_E' => array(
XA_CLASS=>'CVRadio',
XA_NAME_RS=>nothing,
XA_REQUIRED=>false,
XA_LINKED_TO=>'loc_type',
XA_RADIO_VALUE=>'E',
XA_LIST=>'(fd)'
),

'loc_type_R' => array(
XA_CLASS=>'CVRadio',
XA_NAME_RS=>nothing,
XA_REQUIRED=>false,
XA_LINKED_TO=>'loc_type',
XA_RADIO_VALUE=>'R',
XA_LIST=>'(fd)(g_reg_page2)'
),

'loc_type_U' => array(
XA_CLASS=>'CVRadio',
XA_NAME_RS=>nothing,
XA_REQUIRED=>false,
XA_LINKED_TO=>'loc_type',
XA_RADIO_VALUE=>'U',
XA_LIST=>'(fd)(g_reg_page2)'
),

'url_image'=>array(
XA_CLASS=>'cls_cell_url_image',
XA_CAPTION=>array( LC_ENG=>'Image URL' ),
XA_SIZE=>80,
XA_REQUIRED=>$b_guest,
XA_MIN_CHAR=>1,
XA_MAX_CHAR=>500,
XA_SEARCH_OP=>'s%',
XA_LIST=>'(fd)(g_reg_page3R)(g_reg_page4R)'
),

'image_w'=>array(
XA_CLASS=>'CVInteger',
XA_CAPTION=>array( LC_ENG=>'Image Width' ),
XA_SIZE=>6,
XA_REQUIRED=>true,
XA_MIN_CHAR=>1,
XA_MAX_CHAR=>5,
XA_SEARCH_OP=>'s%',
XA_LIST=>'(sr)(fd)(staff)'
),

'image_h'=>array(
XA_CLASS=>'CVInteger',
XA_CAPTION=>array( LC_ENG=>'Image Height' ),
XA_SIZE=>6,
XA_REQUIRED=>true,
XA_MIN_CHAR=>1,
XA_MAX_CHAR=>5,
XA_SEARCH_OP=>'s%',
XA_LIST=>'(sr)(fd)(staff)'
),

'url_link'=>array(
XA_CLASS=>'CVText',
XA_CAPTION=>array( LC_ENG=>'Link URL' ),
XA_SIZE=>80,
XA_REQUIRED=>false,
XA_MIN_CHAR=>1,
XA_MAX_CHAR=>500,
XA_SEARCH_OP=>'s%',
XA_LIST=>'(fd)(g_reg_page5)'
),

'pic'=>array(
XA_CLASS=>'cls_pic_up',
XA_CAPTION=>array( LC_ENG=>'Ad Image' ),
XA_SIZE=>48,
XA_REQUIRED=>false,
XA_MIN_CHAR=>0,
XA_MAX_CHAR=>255,
XA_SEARCH_OP=>'s%',
XA_LIST=>'(fd)(g_reg_page3U)(g_reg_page4U)'
),

'pic_state'=>array(
XA_CLASS=>'CVFileUpload_State',
XA_NAME_RS=>nothing,
XA_CAPTION=>array( LC_ENG=>'Pic_State' ),
XA_LINKED_TO=>'pic',
XA_LIST=>'(fd)(g_reg_page3U)'
),

);

?>
