<?php
/*
=================================================================
AdFreely
Copyright (c) PhpKobo.com ( http://www.phpkobo.com/ )
Email : admin@phpkobo.com
ID : AF201_101

This software is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; version 2 of the
License.
=================================================================
*/

include( 'app/common.inc.php' );

class CPageInstall
{
	var $pageset = 'install';

	//----------------------------------------------------------------
	// setErrMsg
	//----------------------------------------------------------------
	function setErrMsg( $err_msg )
	{
		$this->err_msg = $err_msg;
	}

	//----------------------------------------------------------------
	// getErrMsg
	//----------------------------------------------------------------
	function getErrMsg()
	{
		return $this->err_msg;
	}

	//----------------------------------------------------------------
	// resetError
	//----------------------------------------------------------------
	function resetError()
	{
		$this->err_msg = '';
	}

	//----------------------------------------------------------------
	// isError
	//----------------------------------------------------------------
	function isError()
	{
		return ( $this->err_msg != '' );
	}

	//----------------------------------------------------------------
	// getTableList
	//----------------------------------------------------------------
	function getTableList()
	{
		$ax = array();
		$txt = file_get_contents( "../codelib/cfg/config.table_name.inc.php" );
		$pat = '/define<space>\(<space>\'(<word>)\'<space>,/s';
		$pat = str_replace( "<space>", "\s*", $pat );
		$pat = str_replace( "<word>", "\w+", $pat );
		if ( preg_match_all( $pat, $txt, $matches ) )
		{
			foreach( $matches[1] as $s )
				if ( $s != 'TBL_PREFIX' )
					$ax[] = strtolower( $s );
		}
		return $ax;
	}

	//----------------------------------------------------------------
	// createTables
	//----------------------------------------------------------------
	function createTables()
	{
		$mst =& new CMySqlTool();

		$px['hostname'] = DB_HOSTNAME;
		$px['username'] = DB_USERNAME;
		$px['password'] = DB_PASSWORD;
		$px['database'] = DB_DATABASE;

		$co = "<font color='#008000'>";
		$cc = "</font>";

		//-- testConnection
		$b = $mst->testConnection( $px );
		if ( $mst->isError() )
		{
			$msg = "Can not connect to database server [{$co} {$px['hostname']} {$cc}]";
			$ax = split( ':', $mst->getErrMsg() );
			for( $i = 1; $i < count( $ax ); $i++ )
			{
				$msg = $msg . ' : ' . $ax[$i];
			}
			$this->setErrMsg( $msg );
			return false;
		}

		//-- dbExists
		$b = $mst->dbExists( $px );
		if ( $mst->isError() )
		{
			$this->setErrMsg(
				"Can not find database [{$co} {$px['database']} {$cc}]" );
			return false;
		}

		//-- get table list
		$ax = $this->getTableList();
		// foreach ( $ax as $s ) echo $s;

		//-- tableExists
		foreach ( $ax as $table_name )
		{
			$px['table'] = $table_name;
			$b = $mst->tableExists( $px );
			if ( $mst->isError() )
			{
				$this->setErrMsg( $mst->getErrMsg() );
				return false;
			}

			if ( $b )
			{
				$this->setErrMsg( "Table [{$px['table']}] already exists in [{$px['database']}]" );
				return false;
			}
		}

		//-- create Tables
		$sql = file_get_contents( "sql.txt" );
		$mst->runSqlText( $px, $sql );
		if ( $mst->isError() )
		{
			$this->setErrMsg( $mst->getErrMsg() );
			return false;
		}

		return true;
	}

	//----------------------------------------------------------------
	// showPage
	//----------------------------------------------------------------
	function showPage( $key )
	{
		$sys =& $this;
		include( 'tpl.' . $this->pageset . '.' . $key . '.inc.php' );
	}

	//----------------------------------------------------------------
	// main
	//----------------------------------------------------------------
	function main()
	{
		$this->resetError();
		if ( isset( $_POST['_postback'] ) && ( $_POST['_postback'] == 'y' ) )
		{
			$b = $this->createTables();
			if ( $b )
			{
				$this->showPage( 'done' );
				return;
			}
		}
		$this->showPage( 'home' );
	}
}

//----------------------------------------------------------------
// PageInstall
//----------------------------------------------------------------
$pg =& new CPageInstall();
$pg->main();

?>