function convertSeireki2Nengou( year )
{
	if ( year >= 1989 )
		s = "平成" + (( year - 1989 ) + 1 ).toString();
	else if ( year >= 1927 )
		s = "昭和" + (( year - 1927 ) + 2 ).toString();
	else if ( year >= 1913 )
		s = "大正" + (( year - 1913 ) + 2 ).toString();
	else if ( year >= 1868 )
		s = "明治" + (( year - 1868 ) + 1 ).toString();
	else
		s = year.toString();
	s += "年";

	return s;
}

function parseNengouDate( v )
{
	var f2 = v.substr( 0, 2 );
	if (
		( f2 == '平成' ) ||
		( f2 == '昭和' ) ||
		( f2 == '大正' ) ||
		( f2 == '明治' )
	)
	{
		var val = v.substr( 2 );
		var ax = val.match( /^([0-9]+)年([0-9]+)月([0-9]+)日$/ );
		if (( ax != null ) && ( ax.length == 4 ))
		{
			var year = parseInt( ax[1] );
			var month = parseInt( ax[2] );
			var day = parseInt( ax[3] );
			if (
				( 0 < year ) &&
				( 0 < month ) && ( month <= 12 ) &&
				( 0 < day ) && ( day <= 31 )
			)
			{
				switch( f2 )
				{
				case '平成':
					year += 1988;
					break;

				case '昭和':
					year += 1925;
					break;

				case '大正':
					year += 1911;
					break;

				case '明治':
					year += 1867;
					break;
				}

				var date = new Date( year, month - 1, day );
				if (
					( date.getFullYear() == year ) &&
					( date.getMonth() == month-1 ) &&
					( date.getDate() == day )
				)
				{
					return date;
				}
			}
		}
	}
	
	return null;
}
				
function printNengouDate( d )
{
	s = convertSeireki2Nengou( d.getFullYear() ) + 
		(d.getMonth()+1).toString() + '月' +
		d.getDate().toString() + '日';
	return s;
}

function test_nengou_func( v )
{
	alert( v );
	var d = parseNengouDate( v );
	alert( d );
	if ( d != null ) alert( printNengouDate( d ) );
}

